﻿#pragma strict

/**
 * 敵の役割。
 * 一定期間移動した後自滅する。
 */
public class Enemy extends MonoBehaviour {
	/**
	 * 爆発エフェクトプレハブ。
	 */
	public var explosionPrefab:GameObject;

	/**
	 * タイムアウトまでの時間。（ランダム）
	 */
	private var timeOut:float = Random.Range(3.0, 10.0);

	/**
	 * 移動量。
	 */
	private var MOVE_SPEED:float = 0.06;

	/**
	 * 移動角度。（rad）
	 */
	private var rad:float = Random.Range(-Mathf.PI, Mathf.PI);

	/**
	 * 移動角速度。（rad）
	 */
	private var radSpeed:float = Random.Range(-0.04, 0.04);

	/**
	 * Update.
	 */
	public function Update():void {
		this.timeOut -= Time.deltaTime;

		if (this.timeOut < 0) {
			Destroy(this.gameObject);
		}
		else {
			this.rad += radSpeed;
			this.transform.position.x += Mathf.Cos(this.rad) * this.MOVE_SPEED;
			this.transform.position.z += Mathf.Sin(this.rad) * this.MOVE_SPEED;
		}
	}

	/**
	 * クラッシュ。
	 */
	public function Crush():void {
		var explosionGO:GameObject = Instantiate(this.explosionPrefab);

		explosionGO.transform.position = this.transform.position;

		Destroy(this.gameObject);
	}
}
