﻿#pragma strict

/**
 * ゲーム全体を管理するマネージャー。
 */
public class GameManager extends MonoBehaviour {
	/**
	 * UIManager.
	 */
	private var uiManager:UIManager;

	/**
	 * Start.
	 */
	public function Start():void {
		this.uiManager = GameObject.Find('UI Root').GetComponent(UIManager);
	}

	/**
	 * Update.
	 */
	public function Update():void {
		if (Input.GetMouseButtonDown(0)) {
			var ray:Ray;
			var hit:RaycastHit;
			var enemy:GameObject;

			ray = Camera.main.ScreenPointToRay(Input.mousePosition);

			if (Physics.Raycast(ray, hit, 100)) {
				enemy = hit.collider.gameObject;

				if (enemy) {
					(enemy.GetComponent(Enemy) as Enemy).Crush();

					enemy.transform.position.y += enemy.transform.lossyScale.y;
					this.uiManager.ShowPoint(enemy.transform.position, Random.Range(1, 1000)); // 点数はランダム
				}
			}
		}
	}
}
