﻿#pragma strict

/**
 * UIのマネージャー。
 */
public class UIManager extends MonoBehaviour {
	/**
	 * ポイントのラベル。
	 */
	public var pointLabelPrefab:GameObject;

	/**
	 * 指定の座標に得点を出す。
	 * 上に上がって少し下がる演出。
	 */
	public function ShowPoint(pos:Vector3, point:int):void {
		var pointLabelGO:GameObject = NGUITools.AddChild(this.gameObject, this.pointLabelPrefab);

		(pointLabelGO.GetComponent(UILabel) as UILabel).text = point.ToString();

		var cameraPos = Camera.main.WorldToScreenPoint(pos);
		var pointPos = new Vector3(cameraPos.x - Screen.width / 2, cameraPos.y - Screen.height / 2, 0);

		// 初期位置
		pointLabelGO.transform.localPosition = pointPos;

		// 上昇
		pointPos.y += 40;
		var raiseTween:TweenPosition = TweenPosition.Begin(pointLabelGO, 0.15, pointPos);

		EventDelegate.Add(raiseTween.onFinished, function():void {
			// 下降
			pointPos.y -= 20;
			var fallTween:TweenPosition = TweenPosition.Begin(pointLabelGO, 0.3, pointPos);
			fallTween.method = UITweener.Method.BounceIn;

			EventDelegate.Add(fallTween.onFinished, function():void {
				// // フェード
				var alphaTween:TweenAlpha = TweenAlpha.Begin(pointLabelGO, 0.1, 0);
				alphaTween.delay = 0.2;

				EventDelegate.Add(alphaTween.onFinished, function():void {
					Destroy(pointLabelGO);
				});

			}, true);
		}, true);
	}
}